#include <iostream>
#include <stdio.h>
#include <stdlib.h>
using namespace std;
int nizd[10000],nizg[10000];
void sledeci(int k){
for(int i=1;i<=k;i++)
{
    nizg[i]=nizd[i];
}

}

int main()
{

    int h,n,k,s=0;
    scanf("%d %d",&h,&n);
    for(int i=1;i<=n;i++)
    {
       nizg[i]=1;
    }
    for(int i=1;i<=h;i++)
    { for(int j=1;j<=n;j++) scanf("%d",&nizd[j]);
     for(int j=1;j<=n;j++) {
     k=j;
     while(nizd[j]==0 && j<=n) {s=s+nizg[j]; j++;}

     if(k==j) nizd[j]=nizg[j];
     else if(j>n) {nizd[k-1]=nizd[k-1]+s;}
     else {if(k==1) nizd[j]=nizg[j]+s;
     else if(i%2==0) {nizd[k-1]=nizg[k-1]+s/2; nizd[j]=nizg[j]+(s+1)/2;}
     else {nizd[k-1]=nizg[k-1]+(s+1)/2; nizd[j]=nizg[j]+s/2;}
     }
     s=0; }

      sledeci(n);
    }
    for(int j=1;j<=n;j++)
    {
        printf("%d ",nizd[j]);
    }

    return 0;
}